#include <assert.h>
#include <stddef.h>

#include "exvs2hook/config.h"

#include "platform/config.h"

void exvs2_dll_config_load(
        struct exvs2_dll_config *cfg,
        const wchar_t *filename)
{
    assert(cfg != NULL);
    assert(filename != NULL);

    GetPrivateProfileStringW(
            L"exvs2io",
            L"path",
            L"",
            cfg->path,
            _countof(cfg->path),
            filename);
}

void exvs2_hook_config_load(
        struct exvs2_hook_config *cfg,
        const wchar_t *filename)
{
    assert(cfg != NULL);
    assert(filename != NULL);

    platform_config_load(&cfg->platform, filename);
    exvs2_dll_config_load(&cfg->dll, filename);
    gfx_config_load(&cfg->gfx, filename);
    qr_config_load(&cfg->qr, filename);
    bpreader_config_load(&cfg->reader, filename);
}
