#pragma once

#include <stddef.h>
#include <stdint.h>

struct ferrum_najv4_config {
    uint8_t test;
    uint8_t service;
    uint8_t up;
    uint8_t down;
    uint8_t enter;
    uint8_t coin;
};

struct ferrum_gamepad_config {
    uint8_t dpad_up;
    uint8_t dpad_down;
    uint8_t dpad_left;
    uint8_t dpad_right;
    uint8_t btn_a;
    uint8_t btn_b;
    uint8_t btn_x;
    uint8_t btn_y;
    uint8_t trigger_l;
    uint8_t trigger_r;
    uint8_t btn_start;
};

void ferrum_io_najv4_config_load(struct ferrum_najv4_config *cfg, const wchar_t *filename);
void ferrum_io_gamepad_config_load(struct ferrum_gamepad_config *cfg, const wchar_t *filename);