#pragma once

#include <windows.h>

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

#include "platform/vfs.h"
#include "platform/netenv.h"
#include "platform/locale.h"
#include "platform/clock.h"
#include "platform/platform.h"
#include "platform/dns.h"
#include "platform/misc.h"
#include "platform/es3sec.h"

void platform_config_load(
        struct platform_config *cfg,
        const wchar_t *filename);

void vfs_config_load(struct vfs_config *cfg, const wchar_t *filename);

void netenv_config_load(struct netenv_config *cfg, const wchar_t *filename);

void locale_config_load(struct locale_config *cfg, const wchar_t *filename);

void clock_config_load(struct clock_config *cfg, const wchar_t *filename);

void dns_config_load(struct dns_config *cfg, const wchar_t *filename);

void jvs_config_load(struct jvs_config *cfg, const wchar_t *filename);

void misc_config_load(struct misc_config *cfg, const wchar_t *filename);

void es3sec_config_load(struct es3sec_config *cfg, const wchar_t *filename);